# Contributing to HeliOS
We love that you are interested in joining the HeliOS Project community by contributing to HeliOS. We want to make contributing to this project as easy and seamless as possible, whether it is:

- Reporting a bug
- Submitting a bug fix
- Asking a question
- Proposing new features
- Submitting a new feature
- Improving documentation
- Becoming a maintainer

## We Develop with Github
The HeliOS Project uses GitHub exclusively to maintain a develop HeliOS. The primary methods for contributing to HeliOS are through GitHub Issues and Pull Requests (i.e., PRs).

Submit a:
- **Issue**: If you are reporting a bug, asking a question or proposing a new feature, then submit an issue. Please do not submit source code or other file changes through an issue. If you do, you will be asked to submit a pull request and your issue will be closed. See the **Submitting an Issue** section below for more details.
- **Pull Request**: If you are submitting a bug fix, a new feature or a documentation change, then submit a pull request. See the **Submitting a Pull Request** section below for more details.

## Submitting an Issue

If you are reporting a bug then submit a **Bug Report** issue. Other requests or questions should be submitted using the **Everything Else** issue. If your issue includes formatted text or source code excerpts, please use markdown so your issue is readable. Reading an unformatted source code excerpt is nearly impossible. Please note, the more time you put into submitting a clear and detailed issue, the more helpful we can be to you.

## Submitting a Pull Request

First and foremost, it will take several days before your pull request is merged (if it is merged at all). All pull requests are reviewed multiple times and we may request you make changes before your pull request is merged. Once your pull request is merged, it will not appear in the mainline HeliOS source code until the next release which may be several months away. To submit a pull request, the following **must** be followed:

1. Fork the repo and create your branch from **develop**. Pull requests opened against the **master** branch will be rejected.
2. If you have added a new feature, you **must** add unit tests for the new feature. Pull requests for new features not accompanied by unit tests will be rejected.
3. Your code changes must include code comments (where appropriate) and be accompanied by documentation updates (again, where appropriate).
4. Ensure all unit tests pass.
5. Format your code using Uncrustify. The HeliOS Uncrustify config is available [here](/extras/uncrustify/helios.cfg).
6. Issue that pull request and hang tight! :)

## Copyright & License
In short, when you contribute source code, documentation or other file changes to the HeliOS project, they will fall under the HeliOS Project copyright and license.

## Thank You
Thank you for your contributions to HeliOS.